function limmiLtn3DVis(zscores, ltnVal, res, vis, bsn, intCol);

% Testing case
if vis.t0Flg
   name = 'T0';
end
if vis.t1Flg
   name = 'T1';
end
if vis.t1t0Flg
   name = 'T1-T0';
end

limmitFigCreate('name', name, 'position', [0.05 1 5 5], 'reset', 1);

thresh = str2num(vis.threshVal);

hold on;

if bsn.expInf.pltFlg
   color = bsn.expInf.colVal;
   dat = ltnVal.expInfBin;
   raw = res.expInfRaw;
   bin = res.expInfBin;
   hdr = res.expInfHdr;
   for iPt = 1:size(dat, 1)
      userdata.color = color;
      userdata.hdr = hdr{iPt};
      userdata.raw = raw(:, iPt);
      userdata.bin = bin(:, iPt);
      userdata.thresh = thresh;
      userdata.intCol = intCol;
      id = sprintf('%i', iPt);
      if max(abs(userdata.bin)) < thresh
         h = plot3(dat(iPt, 1), dat(iPt, 2), dat(iPt, 3), 'v');
         set(h, 'MarkerFaceColor', color, 'MarkerEdgeColor', 'k', ...
                'MarkerSize', bsn.expInf.sizVal, 'Marker', bsn.expInf.symTag);
         set(h, 'ButtonDownFcn', ['limmitName name' 'expInf' id], ...
                'userdata', userdata, 'tag', ['name' 'expInf' id]);
      end
   end
end

if bsn.expSup.pltFlg
   color = bsn.expSup.colVal;
   dat = ltnVal.expSupBin;
   raw = res.expSupRaw;
   bin = res.expSupBin;
   hdr = res.expSupHdr;
   for iPt = 1:size(dat, 1)
      userdata.color = color;
      userdata.hdr = hdr{iPt};
      userdata.raw = raw(:, iPt);
      userdata.bin = bin(:, iPt);
      userdata.thresh = thresh;
      userdata.intCol = intCol;
      id = sprintf('%i', iPt);
      % if max(abs([dat(iPt, 1), dat(iPt, 2), dat(iPt, 3)])) < thresh
      if max(abs(userdata.bin)) < thresh
         h = plot3(dat(iPt, 1), dat(iPt, 2), dat(iPt, 3), '^');
         set(h, 'MarkerFaceColor', color, 'MarkerEdgeColor', 'k', ...
                'MarkerSize', bsn.expSup.sizVal, 'Marker', bsn.expSup.symTag);
         set(h, 'ButtonDownFcn', ['limmitName name' 'expSup' id], ...
                'userdata', userdata, 'tag', ['name' 'expSup' id]);
      end
   end
end

if bsn.ctrInf.pltFlg
   color = bsn.ctrInf.colVal;
   dat = ltnVal.ctrInfBin;
   raw = res.ctrInfRaw;
   bin = res.ctrInfBin;
   hdr = res.ctrInfHdr;
   for iPt = 1:size(dat, 1)
      userdata.color = color;
      userdata.hdr = hdr{iPt};
      userdata.raw = raw(:, iPt);
      userdata.bin = bin(:, iPt);
      userdata.thresh = thresh;
      userdata.intCol = intCol;
      id = sprintf('%i', iPt);
      % if max(abs([dat(iPt, 1), dat(iPt, 2), dat(iPt, 3)])) < thresh
      if max(abs(userdata.bin)) < thresh
         h = plot3(dat(iPt, 1), dat(iPt, 2),  dat(iPt, 3), 'v');
         set(h, 'MarkerFaceColor', color, 'MarkerEdgeColor', 'k', ...
                'MarkerSize', bsn.ctrInf.sizVal, 'Marker', bsn.ctrInf.symTag);
         set(h, 'ButtonDownFcn', ['limmitName name' 'ctrInf' id], ...
                'userdata', userdata, 'tag', ['name' 'ctrInf' id]);
      end
   end
end

if bsn.ctrSup.pltFlg
   color = bsn.ctrSup.colVal;
   dat = ltnVal.ctrSupBin;
   raw = res.ctrSupRaw;
   bin = res.ctrSupBin;
   hdr = res.ctrSupHdr;
   for iPt = 1:size(dat, 1)
      userdata.color = color;
      userdata.hdr = hdr{iPt};
      userdata.bin = bin(:, iPt);
      userdata.raw = raw(:, iPt);
      userdata.thresh = thresh;
      userdata.intCol = intCol;
      id = sprintf('%i', iPt);
      % if max(abs([dat(iPt, 1), dat(iPt, 2), dat(iPt, 3)])) < thresh
      if max(abs(userdata.bin)) < thresh
         h = plot3(dat(iPt, 1), dat(iPt, 2), dat(iPt, 3), '^');
         set(h, 'MarkerFaceColor', color, 'MarkerEdgeColor', 'k', ...
                'MarkerSize', bsn.ctrSup.sizVal, 'Marker', bsn.ctrSup.symTag);
         set(h, 'ButtonDownFcn', ['limmitName name' 'ctrSup' id], ...
                'userdata', userdata, 'tag', ['name' 'ctrSup' id]);
      end
   end
end

grid off;
axis square;
set(gca, 'color', [.9 .9 .9], 'xtick', [], 'ytick', [], 'ztick', []);
xlabel('1st PC');
ylabel('2nd PC');
zlabel('3rd PC');
title(name);

expDat = [ltnVal.expInfBin(:, 1:2);ltnVal.expSupBin(:, 1:2)];
ctrDat = [ltnVal.ctrInfBin(:, 1:2);ltnVal.ctrSupBin(:, 1:2)];
allDat = [expDat; ctrDat];

box on;
%__________________________________
%_____________________________________