function varargout = limmitGui(varargin)
% LIMMITGUI M-file for limmitGui.fig
%      LIMMITGUI, by itself, creates a new LIMMITGUI or raises the existing
%      singleton*.
%
%      H = LIMMITGUI returns the handle to a new LIMMITGUI or the handle to
%      the existing singleton*.
%
%      LIMMITGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LIMMITGUI.M with the given input arguments.
%
%      LIMMITGUI('Property','Value',...) creates a new LIMMITGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before limmitGui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to limmitGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help limmitGui

% Last Modified by GUIDE v2.5 06-Jul-2016 13:34:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @limmitGui_OpeningFcn, ...
                   'gui_OutputFcn',  @limmitGui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before limmitGui is made visible.
function limmitGui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to limmitGui (see VARARGIN)

% Choose default command line output for limmitGui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes limmitGui wait for user response (see UIRESUME)
% uiwait(handles.limmitFig);


% --- Outputs from this function are returned to the command line.
function varargout = limmitGui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;
%_______________________________________________________________________________

function kerVal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________________

function xlsBut_Callback(hObject, eventdata, handles)

% Get user dataupdate
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

% Update the configuration structure
hnd.res.cfg = gui2cfg;

% Get data from the xls spread sheet
filename = hnd.res.cfg.rep.valTag;
[hnd.dat hnd.sheet] = limmitXlsGet(filename);

% Set user dataupdate
set(findobj('Tag', 'limmitFig'), 'UserData', hnd);
%_______________________________________________________________________________

function intervalBut_Callback(hObject, eventdata, handles)

% Pointer watch
set(findobj('Tag', 'limmitFig'), 'pointer', 'watch');
drawnow;

% Get user dataupdate
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

% Update the configuration structure
hnd.res.cfg = gui2cfg;

% Get data from the xls spread sheet
filename = hnd.res.cfg.rep.intTag;
[hnd.dat hnd.sheet] = limmitXlsGet(filename);
if isfield(hnd, 'sheet')
   limmitXlsExt(hnd.sheet);
end

% Show default intervals
% limmitDefPlt(dat, dat, hnd);

% Compute intervals based on the GMM scheme
nker = str2num( hnd.res.cfg.prc.kerVal);
hnd.dat = limmitGmmCmp(nker, hnd.dat);

% Find gmm extrema
[xMax, iMax, xMin, iMin] = extrema(hnd.dat.dns);
hnd.dat.minWgt = sort(hnd.dat.allWgt(iMin));
intervals = hnd.dat.minWgt;
[path name] = fileparts(hnd.res.cfg.rep.intTag);
save([path name '.mat'], 'intervals');

% Gmm plot
limmitGmmPlt(hnd.dat, name);

% Set user dataupdate
set(findobj('Tag', 'limmitFig'), 'UserData', hnd);

% Pointer arrow
set(findobj('Tag', 'limmitFig'), 'pointer', 'arrow')
%_______________________________________________________________________________

function visuBut_Callback(hObject, eventdata, handles)

% Pointer watch
set(findobj('Tag', 'limmitFig'), 'pointer', 'watch');
drawnow;

% Get user dataupdate
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

% Load GUI configurations
hnd.res.cfg = gui2cfg;

% Get data from the xls spread sheet
filename = hnd.res.cfg.rep.valTag;
[hnd.dat hnd.sheet] = limmitXlsGet(filename);
if isfield(hnd, 'sheet'); limmitXlsExt(hnd.sheet); end

% Binning
[path name] = fileparts(hnd.res.cfg.rep.intTag);
load([path name '.mat']);
res = limmitBin(hnd.dat, intervals, hnd.res.cfg.vis);

% PCA analysis
[zscores ltnVal] = limmitPcaCmp(res);

% Visualize latent features 
intCol = limmitColors(size(zscores, 2), {'w','k'});
limmiLtn3DVis(zscores, ltnVal, res, hnd.res.cfg.vis, hnd.res.cfg.bsn, intCol);

% Set user dataupdate
set(findobj('Tag', 'limmitFig'), 'UserData', hnd);

% Pointer arrow
set(findobj('Tag', 'limmitFig'), 'pointer', 'arrow')
%_______________________________________________________________________________

function limmitFig_CloseRequestFcn(hObject, eventdata, handles)

% Get user dataupdate
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

% Close xls sheet
% if isfield(hnd, 'sheet'); limmitXlsExt(hnd.sheet); end

% Hint: delete(hObject) closes the figure
delete(hObject);

% Close all figures
close all;
%_______________________________________________________________________________

function expSupBut_Callback(hObject, eventdata, handles)

visuBut_Callback(hObject, eventdata, handles);
%_______________________________________________________________________________

function ctrSupBut_Callback(hObject, eventdata, handles)

visuBut_Callback(hObject, eventdata, handles);
%_______________________________________________________________________________

function expInfBut_Callback(hObject, eventdata, handles)

visuBut_Callback(hObject, eventdata, handles);
%_______________________________________________________________________________

function ctrInfBut_Callback(hObject, eventdata, handles)

visuBut_Callback(hObject, eventdata, handles);
%_______________________________________________________________________________

function saveBut_ClickedCallback(hObject, eventdata, handles)

% Get user data
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

%Get the input file name
[file pathname] = uiputfile({'*.limmit', 'LIMMIT settings (*.limmit)'}, 'Seve the configuration file');
if isequal(file, 0)
   limmitMessage('User pressed cancel');
   return
else
   limmitMessage(['User selected data file:', [pathname file]]);
end

% Reset file name
if ~strcmp(hnd.res.set.file, file)
   copyfile(hnd.res.set.file, [pathname file]);
   hnd.res.set.file = [pathname file];
end

% Set user dataupdate
set(findobj('Tag', 'limmitFig'), 'UserData', hnd);

% Save settings
cfg2rep;
%_______________________________________________________________________

function symTag_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function symTag_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function regFlg_Callback(hObject, eventdata, handles)

cfg2rep;
%_______________________________________________________________________

function edit3_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function edit3_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function pcxFlg_Callback(hObject, eventdata, handles)

cfg2rep;
%_______________________________________________________________________

function pltFlg_Callback(hObject, eventdata, handles)

cfg2rep;
%_______________________________________________________________________

function edit4_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function edit4_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function bsnLst_Callback(hObject, eventdata, handles)

% Get user data
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

% Reload configurations in the GUI
cfg2gui(hnd.res.set.file);
%_______________________________________________________________________

function bsnLst_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function colVal_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function colVal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function edit6_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function edit6_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function sizVal_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function sizVal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function loadBut_ClickedCallback(hObject, eventdata, handles)

% Get user data
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

%Get the input file name
file = uigetfile({'*.limmit', 'LIMMIT settings (*.limmit)'}, 'Pick the configuration file');
if isequal(file, 0)
   limmitMessage('User pressed cancel');
   return
else
   hnd.res.set.file = file;
   limmitMessage(['User selected data file:', hnd.res.set.file]);
end

% Load configurations in the GUI
cfg2gui(hnd.res.set.file);

% Set user data
set(findobj('Tag', 'limmitFig'), 'UserData', hnd);
%_______________________________________________________________________

function intTag_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function intTag_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function valTag_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function valTag_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function colBut_ButtonDownFcn(hObject, eventdata, handles)

% Subset
this = get(findobj('tag', 'bsnLst'), 'value');
if isempty(this); return; end

colGet = get(findobj('tag', 'colVal'), 'string');
colStr = (strsep(colGet, 'sep', ','));
colVal(1) = str2double(colStr{1});
colVal(2) = str2double(colStr{2});
colVal(3) = str2double(colStr{3});
colSet = uisetcolor(colVal);
set(findobj('tag', 'colVal'), 'string', [num2str(colSet(1)) ',' ...
                    num2str(colSet(2)) ',' num2str(colSet(3))]);

% Save settings
cfg2rep;
%_______________________________________________________________________

function sizVal_KeyPressFcn(hObject, eventdata, handles)

if strcmp(eventdata.Key, 'return'); cfg2rep; end
%_______________________________________________________________________

function symTag_KeyPressFcn(hObject, eventdata, handles)

if strcmp(eventdata.Key, 'return'); cfg2rep; end
%_______________________________________________________________________

function valTag_KeyPressFcn(hObject, eventdata, handles)

if strcmp(eventdata.Key, 'return'); cfg2rep; end
%_______________________________________________________________________

function kerVal_Callback(hObject, eventdata, handles)

eventdata

return

if strcmp(eventdata.Key, 'return'); cfg2rep; end
%_______________________________________________________________________

function threshVal_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function threshVal_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function infoTxt_Callback(hObject, eventdata, handles)
%_______________________________________________________________________

function infoTxt_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%_______________________________________________________________________

function threshVal_KeyPressFcn(hObject, eventdata, handles)

if strcmp(eventdata.Key, 'return'); cfg2rep; end
%_______________________________________________________________________

% Get processing settings from the GUI
function cfgNew = gui2cfg

% Get user data
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

% Default processing setting from the file
cfg = limmitCfgGet(hnd.res.set.file);

% Initialize
cfgNew = [];

% Field names
fld1 = fieldnames(cfg);
for iFld1 = 1:length(fld1)
   
   % General processing settings
   if ~strcmp(fld1{iFld1}, 'bsn') && ~strcmp(fld1{iFld1}, 'clc')
      
      % Sub-field names
      fld2 = fieldnames(cfg.(fld1{iFld1}));
      
      for iFld2 = 1:length(fld2)
         
         % Show settings in the GUI
         if strcmp(fld2{iFld2}(end-2:end), 'Tag'); prcSet = get(findobj('Tag', fld2{iFld2}), 'string');end
         if strcmp(fld2{iFld2}(end-2:end), 'Tot'); prcSet = get(findobj('Tag', fld2{iFld2}), 'string');end
         if strcmp(fld2{iFld2}(end-2:end), 'Val'); prcSet = get(findobj('Tag', fld2{iFld2}), 'string'); end
         if strcmp(fld2{iFld2}(end-2:end), 'Flg'); prcSet = get(findobj('Tag', fld2{iFld2}), 'value'); end
         cfgNew.(fld1{iFld1}).(fld2{iFld2}) = prcSet;
         
      end
   end
   
   % Subset specific processing settings
   if strcmp(fld1{iFld1}, 'bsn')
      
      cfgNew.(fld1{iFld1}) = cfg.(fld1{iFld1});
      
      % List of subset names
      bsnLst = get(findobj('tag', 'bsnLst'), 'string');
      
      % Selected subset
      this = get(findobj('tag', 'bsnLst'), 'value');
      if isempty(this); this = 1; end
      bsnNam = bsnLst{this};
      
      % Subset tags
      fld2 = fieldnames(cfg.(fld1{iFld1}).(bsnNam));
      for iFld2 = 1:length(fld2)
         
         % Show processing settings in the GUI
         if strcmp(fld2{iFld2}(end-2:end), 'Tag'); prcSet = get(findobj('Tag', fld2{iFld2}), 'string');end
         if strcmp(fld2{iFld2}(end-2:end), 'Val');
            prcSet = [];
            dummy = get(findobj('Tag', fld2{iFld2}), 'string');
            [dummy nItm] = strsep(dummy, 'sep', ',');
            prcSet(1) = str2double(dummy{1});
            if nItm > 2
               for iItm = 2:nItm; prcSet(iItm) = str2double(dummy{iItm}); end
            end
         end
         if strcmp(fld2{iFld2}(end-2:end), 'Flg'); prcSet = get(findobj('Tag', fld2{iFld2}), 'value'); end
         cfgNew.(fld1{iFld1}).(bsnNam).(fld2{iFld2}) = prcSet;
      end
      
   end
   
end
%_______________________________________________________________________

function cfg2rep

% Get user data
hnd = get(findobj('Tag', 'limmitFig'), 'UserData');

% Update the configuration structure
cfg = gui2cfg;

% commands the output file
fid = fopen(hnd.res.set.file, 'w');

% Field names
fld1 = fieldnames(cfg);
for iFld1 = 1:length(fld1)
   
   % General processing settings
   if ~strcmp(fld1{iFld1}, 'bsn') && ~strcmp(fld1{iFld1}, 'clc')
      
      % Sub-field names
      fld2 = fieldnames(cfg.(fld1{iFld1}));
      for iFld2 = 1:length(fld2)
         
         % Processing setting
         prcSet = [];
         
         % Variable in the structure
         var = cfg.(fld1{iFld1}).(fld2{iFld2});
         
         % The variable is in a numeric format
         if isnumeric(var);
            prcSet = num2str(var(1));
            if length(var) > 1
               for iVar = 2:length(var); prcSet = [prcSet ',' num2str(var(iVar))]; end
            end
         end
         
         % The variable is in a string format
         if ischar(var); prcSet = var; end
         
         % The variable is in a cell format
         if iscell(var)
            
            % With string entries or numeric entries
            if ~isnumeric(var{1})
               prcSet = var{1};
            else
               prcSet = num2str(var{1});
            end
            if length(var) > 1
               for iVar = 2:length(var)
                  if ~isnumeric(var{1})
                     prcSet = [prcSet ',' var{iVar}];
                  else
                     prcSet = [prcSet ',' num2str(var{iVar})];
                  end
               end
            end
         end
         
         % Write the setting
         fprintf(fid, '\\%s.%s=%s\n', fld1{iFld1}, fld2{iFld2}, prcSet);
         
      end
   end
   
   % Subset specific processing settings
   if strcmp(fld1{iFld1}, 'bsn')
      
      % List of subset names
      bsnLst = fieldnames(cfg.(fld1{iFld1}));
      
      for iBsn = 1:length(bsnLst)
         
         bsnNam = bsnLst{iBsn};
         
         % Subset tags
         fld2 = fieldnames(cfg.(fld1{iFld1}).(bsnNam));
         for iFld2 = 1:length(fld2)
            
            % Reset processing settings
            prcSet = [];
            
            % Variable in the strucutre
            var = cfg.(fld1{iFld1}).(bsnNam).(fld2{iFld2});
            
            % The variable is in a numeric format
            if isnumeric(var)
               prcSet = num2str(var(1));
               if length(var) > 1
                  for iVar = 2:length(var); prcSet = ...
                             [prcSet ',' num2str(var(iVar))]; end;
                  end
               end
               
               % The variable is in a string format
               if ischar(var); prcSet = var; end
               
               % The variable is in a cell format
               if iscell(var)
                  
                  % With numeric or string entries
                  if ~isnumeric(var{1})
                     prcSet = var{1};
                  else
                     prcSet = num2str(var{1});
                  end
                  if length(var) > 1
                     for iVar = 2:length(var)
                        if ~isnumeric(var{1})
                           prcSet = [prcSet ',' var{iVar}];
                        else
                           prcSet = [prcSet ',' num2str(var{iVar})];
                        end
                     end
                  end
               end
               
               fprintf(fid, '\\%s.%s.%s=%s\n', fld1{iFld1}, bsnNam, ...
                       fld2{iFld2}, prcSet);
               
            end
         end
      end
   end

% Confirmation
limmitMessage(['Configuration saved in:', hnd.res.set.file]);

% Load configurations in the GUI
cfg2gui(hnd.res.set.file);
%_______________________________________________________________________

function cfg2gui(filename)

% Get processin setting from the file
cfg = limmitCfgGet(filename);

% Field names
fld1 = fieldnames(cfg);
for iFld1 = 1:length(fld1)
   
   % General processing settings
   if ~strcmp(fld1{iFld1}, 'bsn') && ~strcmp(fld1{iFld1}, 'clc')
      
      % Sub-field names
      fld2 = fieldnames(cfg.(fld1{iFld1}));
      for iFld2 = 1:length(fld2)
         
         % Processing setting
         prcSet = [];
         
         % Variable in the structure
         var = cfg.(fld1{iFld1}).(fld2{iFld2});
         
         % The variable is in a numeric format
         if isnumeric(var);
            prcSet = num2str(var(1));
            if length(var) > 1
               for iVar = 2:length(var); prcSet = [prcSet ',' num2str(var(iVar))]; end %#ok<*AGROW>
            end
         end
         
         % The variable is in a string format
         if ischar(var); prcSet = var; end
         
         % The variable is in a cell format
         if iscell(var)
            
            % With string entries or numeric entries
            if ~isnumeric(var{1})
               prcSet = var{1};
            else
               prcSet = num2str(var{1});
            end
            if length(var) > 1
               for iVar = 2:length(var)
                  if ~isnumeric(var{1})
                     prcSet = [prcSet ',' var{iVar}];
                  else
                     prcSet = [prcSet ',' num2str(var{iVar})];
                  end
               end
            end
         end
         
         % Show settings in the GUI
         if strcmp(fld2{iFld2}(end-2:end), 'Tag'); set(findobj('Tag', fld2{iFld2}), 'string', prcSet);end
         if strcmp(fld2{iFld2}(end-2:end), 'Tot'); set(findobj('Tag', fld2{iFld2}), 'string', prcSet);end
         if strcmp(fld2{iFld2}(end-2:end), 'Val'); set(findobj('Tag', fld2{iFld2}), 'string', prcSet); end
         if strcmp(fld2{iFld2}(end-2:end), 'Flg'); set(findobj('Tag', fld2{iFld2}), 'value', str2double(prcSet)); end
         
      end
   end
   
   % Subset specific processing settings
   if strcmp(fld1{iFld1}, 'bsn')
      
      % List of subset names
      bsnLst = fieldnames(cfg.(fld1{iFld1}));
      set(findobj('tag', 'bsnLst'), 'string', bsnLst);
      
      % Selected subset
      this = get(findobj('tag', 'bsnLst'), 'value');
      if isempty(this); this = 1; end
      bsnNam = bsnLst{this};
      
      % Subset tags
      fld2 = fieldnames(cfg.(fld1{iFld1}).(bsnNam));
      for iFld2 = 1:length(fld2)
         
         % Reset processing settings
         prcSet = [];
         
         % Variable in the strucutre
         var = cfg.(fld1{iFld1}).(bsnNam).(fld2{iFld2});
         
         % The variable is in a numeric format
         if isnumeric(var)
            prcSet = num2str(var(1));
            if length(var) > 1
               for iVar = 2:length(var); prcSet = [prcSet ',' num2str(var(iVar))]; end
            end
         end
         
         % The variable is in a string format
         if ischar(var); prcSet = var; end
         
         % The variable is in a cell format
         if iscell(var)
            
            % With numeric or string entries
            if ~isnumeric(var{1})
               prcSet = var{1};
            else
               prcSet = num2str(var{1});
            end
            if length(var) > 1
               for iVar = 2:length(var)
                  if ~isnumeric(var{1})
                     prcSet = [prcSet ',' var{iVar}];
                  else
                     prcSet = [prcSet ',' num2str(var{iVar})];
                  end
               end
            end
         end
         
         % Show processing settings in the GUI
         if strcmp(fld2{iFld2}(end-2:end), 'Tag'); set(findobj('Tag', fld2{iFld2}), 'string', prcSet);end
         if strcmp(fld2{iFld2}(end-2:end), 'Val'); set(findobj('Tag', fld2{iFld2}), 'string', prcSet);end
         if strcmp(fld2{iFld2}(end-2:end), 'Flg'); set(findobj('Tag', fld2{iFld2}), 'value', str2double(prcSet)); end
         
      end
   end
end

% List of subset names
bsnLst = get(findobj('tag', 'bsnLst'), 'string');

% Subset color
this = get(findobj('tag', 'bsnLst'), 'value');
if isempty(this); this = 1; end
bsnNam = bsnLst{this};
set(findobj('tag', 'colBut'), 'BackgroundColor', cfg.bsn.(bsnNam).colVal);
%_______________________________________________________________________

function kerVal_KeyPressFcn(hObject, eventdata, handles)
%_______________________________________________________________________

function copyBut_ClickedCallback(hObject, eventdata, handles)

cfg2rep;
%_______________________________________________________________________
