
% Read the configuration file
hnd.cfg = limmitConfRead('limmit.cfg');

% Get data from the xls spread sheet
[dat sheet] = limmitXlsGet(hnd);

% Show default intervals
% limmitDefPlt(dat, dat, hnd);

% Compute intervals based on the GMM scheme
dat = limmitGmmCmp(hnd.cfg.nker, dat);

% Find gmm extrema
[xMax, iMax, xMin, iMin] = extrema(dat.dns);
dat.minWgt = sort(dat.allWgt(iMin));

% Gmm plot
limmitGmmPlt(dat, hnd);

% Binning
expMod = 't1-t0';
res = limmitBin(dat, expMod);

% PCA analysis
[zscores ltnVal] = limmitPcaCmp(res);

% Visualize latent features 
intCol = limmitColors(hnd.cfg.nker, {'w','k'});
limmiLtnVis(zscores, ltnVal, res, expMod, intCol);

% Close xls sheet
limmitXlsExt(sheet);
%_______________________________________________________________________

% figure;
% plot3(zscores(:, 1), zscores(:, 2), zscores(:, 3), 'ko');
% hold on;
% idx = expInfIdx;
% color = 'r';
% h = plot3(zscores(idx, 1), zscores(idx, 2), zscores(idx, 3), 'o');
% set(h, 'MarkerFaceColor', color);
% idx = expSupIdx;
% color = 'r';
% h = plot3(zscores(idx, 1), zscores(idx, 2), zscores(idx, 3), 'o');
% set(h, 'MarkerFaceColor', color);
% idx = ctrSupIdx;
% color = 'b';
% h = plot3(zscores(idx, 1), zscores(idx, 2), zscores(idx, 3), 'o');
% set(h, 'MarkerFaceColor', color);
% idx = ctrInfIdx;
% color = 'b';
% h = plot3(zscores(idx, 1), zscores(idx, 2), zscores(idx, 3), 'o');
% set(h, 'MarkerFaceColor', color);