%stat: functio for computing some statistical parameters
%(relative error, root mean square relative difference, 
%root mean square difference and coefficient of determination)

function coe = stat (arr1, arr2)

%n samples
nsamp = length(arr1);
coe.nsamp = nsamp;

%relative error
relerr = 0;
for i = 1:nsamp;
   relerr = relerr+abs((arr1(i)-arr2(i))/arr1(i));
end
coe.relerr = relerr/nsamp;
coe.relerrArr = abs((arr1 - arr2) ./ arr1);

%unsigned relative error
unsrelerr = 0;
for i = 1:nsamp;
   unsrelerr = unsrelerr+((arr2(i)-arr1(i))/arr1(i));
end
coe.unsrelerr = unsrelerr/nsamp;

%root mean square relative difference
rmsrd = 0;
for i = 1:nsamp;
   rmsrd = rmsrd+((arr2(i)-arr1(i))./arr1(i))^2.;
end
coe.rmsrd = sqrt(rmsrd/nsamp);

%root mean square difference
rms = 0;
for i = 1:nsamp;
   rms = rms+(arr1(i)-arr2(i))^2.;
end
coe.rms = sqrt(rms/nsamp);

%coefficient of determination
corrcoe = corrcoef(arr1, arr2);
coe.detcoe = (corrcoe(2, 1))^2;

%______________________________________________________________________________
